#include <SoftwareSerial.h>

SoftwareSerial mySerial(2, 3); // RX, TX

const int HP1 = A0;
const int HP2 = A1;
const int HP3 = A2;
const int HP4 = A3;
const int HP5 = A4;
const int HP6 = A5;
int sensorHigh[6];
int sensorValue[6];
int t;


int volume=0;
int chords=0;
int noteLength=0;
// Il valore della nota MIDI che deve essere suonata
int note = 0; //The MIDI note value to be played
//Collegat al VS1053 Reset line
byte resetMIDI = 4; //Tied to VS1053 Reset line
byte ledPin = 13; //MIDI traffic inidicator
int loopCount=0;
int button=0;

int  instrument = 1;

//questo controlla se la nota sta suonando
boolean notes[10] = {false, false, false, false, false, false, false, false, false, false}; // this checks to see if a note is currently playing
//inserisci il valore delle 10 note qui NON MODIFICARE QUESTO CON FUNZIONI
byte noteValue[10] = {48, 51, 53, 54, 55, 58, 0, 0, 0, 0}; // put the values of the 10 notes here DO NOT MODIFY THIS WITH FUNCTIONS
                    //48, 51, 53, 54, 55, 58  Blues Scale

//controlla quali note dovrebbe suonare questo turno
boolean noteBuffer[10] = {false, false, false, false, false, false, false, false, false, false};  // checks which notes should play this round


void setup() {
  Serial.begin(57600);

  //Setup soft serial for MIDI control
  mySerial.begin(31250);

  //Reset the VS1053
  pinMode(resetMIDI, OUTPUT);
  digitalWrite(resetMIDI, LOW);
  delay(100);
  digitalWrite(resetMIDI, HIGH);
  delay(100);
  //0xB0 è un messaggio canale, imposta il volume del canale verso il massimo (127)
  talkMIDI(0xB0, 0x07, 120); //0xB0 is channel message, set channel volume to near max (127)


  for(int i = A0; i <= A5; i++){
    pinMode(i,INPUT);
  }

  for(int i=0;i<6;i++){
    sensorHigh[i] = 0;
  }

  for(int i=0, j=A0; i<6, j <= A5; i++, j++){                      
     t=millis();
     do{
      sensorValue[i]=analogRead(j);
      if(sensorValue[i]>sensorHigh[i]){
         sensorHigh[i]=sensorValue[i]; 
      }
      Serial.println(sensorValue[i]);
     }while(millis()-t<=1000);
     Serial.println(sensorHigh[i]);
  }

  for(int i = 0; i<10; i++){
    noteBuffer[i] = true;
  }
  playNotes();


  for(int i = 0; i<10; i++){
    noteBuffer[i] = false;
  }
  
  delay(1000);
}

void loop() {

  talkMIDI(0xB0, 0, 0x79); //Bank select Melodic //Default bank GM1
  talkMIDI(0xC0, instrument, 0); //Set instrument number. 0xC0 is a 1 data byte command

      sensorValue[0] = analogRead(A0);
      if(sensorValue[0]>sensorHigh[0]+30 ){
        noteBuffer[0] = true;
      }

      sensorValue[1] = analogRead(A1);
      if(sensorValue[1]>sensorHigh[1]+30){
        noteBuffer[1]=true;
      }

      sensorValue[2] = analogRead(A2);
      if(sensorValue[2]>sensorHigh[2]+30){
        noteBuffer[2] = true;
      }

      sensorValue[3] = analogRead(A3);
      if(sensorValue[3]>sensorHigh[3]+30){
        noteBuffer[3] = true;   
      }

      sensorValue[4] = analogRead(A4);
      if(sensorValue[4]>sensorHigh[4]+30){
        noteBuffer[4] = true;  
      }

      sensorValue[5] = analogRead(A5);
      if(sensorValue[5]>sensorHigh[5]+30){
        noteBuffer[5] = true;  
      }
      
      playNotes();

      Serial.println(" A0: " + String(sensorValue[0])+" "+String(sensorHigh[0]) + " A1: " + String(sensorValue[1])+" "+String(sensorHigh[1]) + " A2: " + String(sensorValue[2])+" "+String(sensorHigh[2]) + " A3: " + String(sensorValue[3])+" "+String(sensorHigh[3]) + " A4: " + String(sensorValue[4])+" "+String(sensorHigh[4]) + " A5: " + String(sensorValue[5])+" "+String(sensorHigh[5]));
      
  delay(50);
}

void playMyNote(byte note, int boolValue){
    // check to see if note is playing
    if(!notes[boolValue]){
      //play note
      noteOn(0, note, 126);
      // array reflects note playing
      notes[boolValue] = true;
      }
  }
void stopMyNote(byte note, int boolValue){
    if(notes[boolValue]){
      noteOff(0, note, 126);
      notes[boolValue] = false;
      }
  }

void stopAllOtherNotes(byte note){
  for(int i = 0; i<10; i++){
    if(noteValue[i] != note){
      stopMyNote(noteValue[i], i);
    }
  }
}

void playNotes(){
  // traverse buffer
  for(int i = 0; i<10; i++){
    if(noteBuffer[i]){
      playMyNote(noteValue[i], i);
      }
    else{stopMyNote(noteValue[i], i);}
    }
   // clear buffer
  for(int i = 0; i<10; i++){
      noteBuffer[i] = false;
    }
  }

  
void noteOn(byte channel, byte note, byte attack_velocity) {
  talkMIDI( (0x90 | channel), note, attack_velocity);
}

//Send a MIDI note-off message.  Like releasing a piano key
void noteOff(byte channel, byte note, byte release_velocity) {
  talkMIDI( (0x80 | channel), note, release_velocity);
}

//suona la nota MIDI. Non controlla se cmd è più grande di 127, oppurese quei valori son inferiori di 127
//Plays a MIDI note. Doesn't check to see that cmd is greater than 127, or that data values are less than 127
void talkMIDI(byte cmd, byte data1, byte data2) {
  digitalWrite(ledPin, HIGH);
  mySerial.write(cmd);
  mySerial.write(data1);

  //Some commands only have one data byte. All cmds less than 0xBn have 2 data bytes 
  //(sort of: http://253.ccarh.org/handout/midiprotocol/)
  if( (cmd & 0xF0) <= 0xB0)
    mySerial.write(data2);

  digitalWrite(ledPin, LOW);
 }
void turnNotesOff(){
  for(int i = 0; i < 200; i++){
    noteOff(0, i, 120);
  }
}
